# Download and Run

## Download

Version `~~~${VERSION}~~~` [changelog](about/changelog.md)

OS              | CPU Platform  | Download
--------------- | ------------- | ----------------------------------------------------------------------
Windows			| 64 bit		| [stream-server.exe](/bin/~~~${VERSION}~~~/windows-x86_64/stream-server.exe)
&nbsp;			| 32 bit		| [stream-server.exe](/bin/~~~${VERSION}~~~/windows-x86/stream-server.exe)
Linux 			| 64 bit		| [stream-server](/bin/~~~${VERSION}~~~/linux-x86_64/stream-server)
&nbsp;			| 32 bit		| [stream-server](/bin/~~~${VERSION}~~~/linux-x86/stream-server)
&nbsp;			| ARM64			| [stream-server](/bin/~~~${VERSION}~~~/linux-arm64/stream-server)
&nbsp;			| ARM32			| [stream-server](/bin/~~~${VERSION}~~~/linux-arm/stream-server)
Darwin (macOS)	| 64 bit		| [stream-server](/bin/~~~${VERSION}~~~/darwin-x86_64/stream-server)
&nbsp;			| 32 bit		| [stream-server](/bin/~~~${VERSION}~~~/darwin-x86/stream-server)

??? expert info
	If you do not wish to use a precompiled executable you can [compile it yourself](/about/contributing/#server).

## Run

### Windows
1. Just double-click the exe or run it in a cmd or PowerShell `.\stream-server.exe`.
2. *Optional:* Provide [command-line options](options.md).

!!! warning
	If you get [this](/assets/windows-protected-your-pc.png) *"Windows protected your PC"* warning press <kbd>More info</kbd> and <kbd>Run anyway</kbd>.

### Linux
1. Assign the file execute permission in a terminal: `chmod +x stream-server`.
2. Run it from the terminal `./stream-server`.
3. *Optional:* Provide [command-line options](options.md).

### Darwin (macOS) <small>in the Terminal</small>
1. Assign the file execute permission in a terminal: `chmod +x stream-server`.
2. Run it from the terminal `./stream-server`.
3. *Optional:* Provide [command-line options](options.md).

### Darwin (macOS) <small>from the GUI</small>
1. Assign the file execute permission in a terminal: `chmod +x stream-server`.

	!!! important
		This is important as otherwise macOS will try to edit the file in TextEdit when you open it.

2. In Finder right click the file and <kbd>Open</kbd>.
3. Confirm the dialog again with <kbd>Open</kbd>.

!!! info
	After the first launch the file can just be double-clicked.  
	Read more: [Open an app from an unidentified developer](https://help.apple.com/machelp/mac/10.12/index.html?localePath=en.lproj#/mh40616).

## Common Errors

*	listen tcp 0.0.0.0:80: bind: permission denied

	> The port range below 1024 is restricted on \*nix systems to superusers ([more info](https://unix.stackexchange.com/a/16568)).  
	> Either run as superuser `sudo ./stream-server -p 80` or change the port.

* 	listen tcp 0.0.0.0:8080: bind: address already in use

	> Something is already using the port. This could be another Stream Server instance or some other application (like a webserver).  
	> Close / disable the other service or change the port via the [command-line options](options.md).
