# Stream Server

Stream Server is a project developed at Darmstadt University of Applied Sciences [h-da.de](https://h-da.de) for the User-Centric Software Development hands-on training. In the course the students develop an Android app that remote controls the Stream Server.

This server displays streams of the popular [Twitch.tv](https://twitch.tv) livestream platform on the student's target device (laptop, desktop, tv, smart device, etc.).
The apps can request the server via a simple HTTP API to query the Twitch API for content and to change the state of the display (e.g. control playback).

The project is intended as an direct successor to the [TV Server](https://lernen.h-da.de/course/view.php?id=6802) which displays static still frames of german TV channels.

The goal was to

- **Increase student engagement** by providing access to a modern engaging platform that the students either already know or can quickly adapt to.

- **Differentiate app designs and diversify stereotypes:** The legacy TV Server only has one endpoint to *discover* content. By providing 7 distinct endpoints to the Twitch API students can differentiate themselves in their project, stereotypes and design. Of course that doesn't mean all endpoints must be used.

- **Improve usefulness:** The apps for the legacy TV Server have no use after and outside the course. We hope that our project enables apps to exceed this lifespan.

## Documentation layout

- **Stream Server**  
  _What you are reading right now_, [Download and Run](download-and-run.md), [Options](options.md), [Quickstart](quickstart.md), [Reference](reference.md) and [Android Integration](android-integration.md).

- **About**  
  [Changelog](about/changelog.md), [Contributing info (code layout, build and deploy instructions etc.)](about/contributing.md), [Author's Notes](about/authors-notes.md), [Previous Considerations](about/previous-considerations.md) and [License](about/license.md).


!!! info
    For the hands-on training not every page in this documentation is important. The _About_ chapter is mostly for internal purposes and curious readers.
    